"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.productRouter = void 0;
const express_1 = require("express");
const product_record_1 = require("../records/product.record");
exports.productRouter = (0, express_1.Router)();
exports.productRouter
    .get('/singleShop/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const allProductsFromSingleShop = yield product_record_1.ProductRecord.getAllProductsFromSingleShop(req.params.id);
    res.json(allProductsFromSingleShop);
}))
    .get('/singleProduct/:shopId/:productName', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const oneProductFromSingleShop = yield product_record_1.ProductRecord.getOneProductFromSingleShop(req.params.shopId, req.params.productName);
    res.json(oneProductFromSingleShop);
}))
    .post('/add', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const newProduct = new product_record_1.ProductRecord(req.body);
    yield newProduct.insert();
    res.json(newProduct);
}));
//# sourceMappingURL=product.router.js.map