"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.shopRouter = void 0;
const express_1 = require("express");
const shop_record_1 = require("../records/shop.record");
const product_record_1 = require("../records/product.record");
exports.shopRouter = (0, express_1.Router)();
exports.shopRouter
    .get('/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const shops = yield shop_record_1.ShopRecord.getAll();
    res.json(shops);
}))
    .get('/:productName', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const shopsWithTheProduct = yield shop_record_1.ShopRecord.getAllShopsWithTheProduct(req.params.productName);
    res.json(shopsWithTheProduct);
}))
    .get('/single/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const shopToView = yield shop_record_1.ShopRecord.getOne(req.params.id);
    res.json(shopToView);
}))
    .get('/showSingle/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const shopToView = yield shop_record_1.ShopRecord.getOne(req.params.id);
    const allProducts = yield product_record_1.ProductRecord.getAll();
    const productsToView = allProducts.filter(product => product.shop_id === req.params.id);
    res.json({
        shopToView,
        productsToView,
    });
}))
    .get('/edit/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const shopToEdit = yield shop_record_1.ShopRecord.getOne(req.params.id);
    res.json(shopToEdit);
}))
    .delete('/delete/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const shopToDelete = yield shop_record_1.ShopRecord.getOne(req.params.id);
    const shopName = shopToDelete.name;
    yield shopToDelete.delete();
    res.json(shopName);
}))
    .post('/add', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const newShop = new shop_record_1.ShopRecord(req.body);
    yield newShop.insert();
    res.json(newShop);
}));
//# sourceMappingURL=shop.router.js.map